From 869e07067b15e09bf7ef886a8772afdfb79cbc3c Mon Sep 17 00:00:00 2001
From: Tuukka Pasanen <tuukka.pasanen@ilmi.fi>
Date: Sat, 9 May 2015 12:08:37 +0300
Subject: [PATCH] New FFMpeg/AVConv depricates new functions. #ifdef them to
 support old and new

---
 src/encoder/encoderffmpegcore.cpp | 31 ++++++++++++++++++++++++++-----
 1 file changed, 26 insertions(+), 5 deletions(-)

diff --git a/src/encoder/encoderffmpegcore.cpp b/src/encoder/encoderffmpegcore.cpp
index d062c01..343fb66 100644
--- a/src/encoder/encoderffmpegcore.cpp
+++ b/src/encoder/encoderffmpegcore.cpp
@@ -273,7 +273,11 @@ int EncoderFfmpegCore::writeAudioFrame(AVFormatContext *formatctx,
                                        AVStream *stream) {
     AVCodecContext *l_SCodecCtx = NULL;;
     AVPacket l_SPacket;
+#if LIBAVCODEC_VERSION_INT < 3617792
     AVFrame *l_SFrame = avcodec_alloc_frame();
+#else
+    AVFrame *l_SFrame = av_frame_alloc();
+#endif
     int l_iGotPacket;
     int l_iRet;
     uint8_t *l_iOut = NULL;
@@ -326,13 +330,24 @@ int EncoderFfmpegCore::writeAudioFrame(AVFormatContext *formatctx,
         m_pResample->reSample(l_SFrame, &l_iOut);
         // After we have turned our samples to destination
         // Format we must re-alloc l_SFrame.. it easier like this..
-#if LIBAVCODEC_VERSION_INT > 3544932
-        avcodec_free_frame(&l_SFrame);
-#else
+        // FFMPEG 2.2 3561060 anb beyond
+#if LIBAVCODEC_VERSION_INT >= 3561060
+        av_frame_unref(l_SFrame);
+        av_frame_free(&l_SFrame);
+// FFMPEG 0.11 and below
+#elif LIBAVCODEC_VERSION_INT <= 3544932
         av_free(l_SFrame);
-#endif // LIBAVCODEC_VERSION_INT > 3544932
+// FFMPEG 1.0 - 2.1
+#else
+        avcodec_free_frame(&l_SFrame);
+#endif
         l_SFrame = NULL;
+
+#if LIBAVCODEC_VERSION_INT < 3617792
         l_SFrame = avcodec_alloc_frame();
+#else
+        l_SFrame = av_frame_alloc();
+#endif
         l_SFrame->nb_samples = m_iAudioInputFrameSize;
         l_SFrame->format = l_SCodecCtx->sample_fmt;
 #ifndef __FFMPEGOLDAPI__
@@ -385,13 +400,15 @@ int EncoderFfmpegCore::writeAudioFrame(AVFormatContext *formatctx,
     l_SPacket.dts = m_lDts;
     l_SPacket.pts = m_lDts;
 
+#if LIBAVCODEC_VERSION_INT < 3617792
     // Some times den is zero.. so 0 dived by 0 is
     // Something?
     if (m_pEncoderAudioStream->pts.den == 0) {
         qDebug() << "Time hack!";
         m_pEncoderAudioStream->pts.den = 1;
     }
-
+#endif
+    
     // Write the compressed frame to the media file. */
     l_iRet = av_interleaved_write_frame(formatctx, &l_SPacket);
 
@@ -401,7 +418,11 @@ int EncoderFfmpegCore::writeAudioFrame(AVFormatContext *formatctx,
     }
 
     av_free_packet(&l_SPacket);
+#if LIBAVCODEC_VERSION_INT < 3617792
     av_destruct_packet(&l_SPacket);
+#else
+    av_free_packet(&l_SPacket);
+#endif
     av_free(l_SFrame);
 
     return 0;
